# For support email: support@rocketship.it
# For usage: https://docs.rocketship.it/2-0/

import pprint

from rocketshipit import RocketShipIt

# You can get your RocketShipIt API key from: https://www.rocketship.it/account
RS_API_KEY = 'CHANGE_ME'

# For carrier API keys see: https://docs.rocketship.it/php/1-0/getting-started.html#obtaining-carrier-developer-keys
UPS_USERNAME = 'CHANGE_ME'
UPS_PASSWORD = 'CHANGE_ME'
UPS_API_KEY = 'CHANGE_ME'
UPS_ACCOUNT_NUMBER = 'CHANGE_ME'

# Rate example
rs = RocketShipIt()
resp = rs.request(
    'UPS', # Carrier type
    'GetAllRates',
    {
    "packages": [
      {
        "weight": 5,
        "length": 5,
        "width": 5,
        "height": 5
      }
    ],
    "customs": [],
    "shipper": "RocketShipIt",
    "ship_addr1": "201 1\/2 W 2nd St.",
    "ship_city": "Whitehall",
    "ship_state": "MT",
    "ship_code": "59759",
    "ship_country": "US",
    "to_country": "US",
    "to_code": "90210",
    "weight_unit": "LBS",
    "pickup_type": "01",
    "customer_classification": "01",
    "length_unit": "IN",
    "packaging_type": "02"
    }
)

pp = pprint.PrettyPrinter(indent=4)
pp.pprint(resp)

# For a full list of parameters
# See: https://docs.rocketship.it/php/1-0/index.html#reference
# resp = rate.get_all_rates(
#     {
#     "packages": [
#       {
#         "weight": 5,
#         "length": 5,
#         "width": 5,
#         "height": 5
#       }
#     ],
#     "debugMode": True, # Uses carrier test servers
#     "username": UPS_USERNAME,
#     "password": UPS_PASSWORD,
#     "accountNumber": UPS_ACCOUNT_NUMBER,
#     "license": UPS_API_KEY,
#     "shipper": "RocketShipIt",
#     "shipAddr1": "201 1\/2 W 2nd St.",
#     "shipCity": "Whitehall",
#     "shipState": "MT",
#     "shipCode": "59759",
#     "shipCountry": "US",
#     "toCountry": "US",
#     "toCode": "90210",
#     "weightUnit": "LBS",
#     "pickupType": "01",
#     "customerClassification": "01",
#     "lengthUnit": "IN",
#     "packagingType": "02",
#     #"debug": True, # Will return debug information
#     }
# )

