<?php

class Limex_B2b_Block_Adminhtml_B2b_Grid extends Mage_Adminhtml_Block_Widget_Grid
{
  public function __construct()
  {
      parent::__construct();
      $this->setId('b2bGrid');
      $this->setDefaultSort('b2b_id');
      $this->setDefaultDir('ASC');
      $this->setSaveParametersInSession(true);
  }

  protected function _prepareCollection()
  {
      $collection = Mage::getModel('b2b/b2b')->getCollection();
      $this->setCollection($collection);
      return parent::_prepareCollection();
  }

  protected function _prepareColumns()
  {
      $this->addColumn('b2b_id', array(
          'header'    => Mage::helper('b2b')->__('ID'),
          'align'     =>'right',
          'width'     => '50px',
          'index'     => 'b2b_id',
      ));

      $this->addColumn('email_id', array(
          'header'    => Mage::helper('b2b')->__('Emaild Id'),
          'align'     =>'left',
          'index'     => 'email_id',
      ));
	  
	  
	   $this->addColumn('password', array(
          'header'    => Mage::helper('b2b')->__('Password'),
          'align'     =>'left',
          'index'     => 'password',
      ));
	  
	   $this->addColumn('price', array(
          'header'    => Mage::helper('b2b')->__('Cost'),
          'align'     =>'left',
          'index'     => 'price',
      ));
	  
	   $this->addColumn('created_date', array(
          'header'    => Mage::helper('b2b')->__('Created'),
          'align'     =>'left',
          'index'     => 'created_date',
      ));
	  
	   $this->addColumn('update_date', array(
          'header'    => Mage::helper('b2b')->__('Updated'),
          'align'     =>'left',
          'index'     => 'update_date',
      ));

	  /*
      $this->addColumn('content', array(
			'header'    => Mage::helper('b2b')->__('Item Content'),
			'width'     => '150px',
			'index'     => 'content',
      ));
	  */

        $this->addColumn('action',
            array(
                'header'    =>  Mage::helper('b2b')->__('Action'),
                'width'     => '100',
                'type'      => 'action',
                'getter'    => 'getId',
                'actions'   => array(
                    array(
                        'caption'   => Mage::helper('b2b')->__('Edit'),
                        'url'       => array('base'=> '*/*/edit'),
                        'field'     => 'id'
                    )
                ),
                'filter'    => false,
                'sortable'  => false,
                'index'     => 'stores',
                'is_system' => true,
        ));
		
      return parent::_prepareColumns();
  }

    protected function _prepareMassaction()
    {
        $this->setMassactionIdField('b2b_id');
        $this->getMassactionBlock()->setFormFieldName('b2b');

        $this->getMassactionBlock()->addItem('delete', array(
             'label'    => Mage::helper('b2b')->__('Delete'),
             'url'      => $this->getUrl('*/*/massDelete'),
             'confirm'  => Mage::helper('b2b')->__('Are you sure?')
        ));

        return $this;
    }

  public function getRowUrl($row)
  {
      return $this->getUrl('*/*/edit', array('id' => $row->getId()));
  }

}