<?php

class Magegiant_Affiliatereport_Block_Frontend_Diagrams_Transactions extends Magegiant_Affiliatereport_Block_Diagrams_Graph
{
    protected $_google_chart_params = array(
        'cht'        => 'lc',
        'chf'        => 'bg,s,f4f4f4|c,lg,90,ffffff,0.1,ededed,0',
        'chm'        => 'B,f4d4b2,0,0,0',
        'chco'       => 'db4814',
        'chxt'       => 'x,y,y',
        'chxlexpend' => '|2:|||(transactions)'
    );

    public function __construct()
    {
        $this->setHtmlId('transactions');
        parent::__construct();
    }

    /**
     * get Helper
     *
     * @return Magegiant_Affiliate_Helper_Config
     */
    public function _getHelper()
    {
        return Mage::helper('affiliate/config');
    }

    protected function _prepareData()
    {
        $this->setDataHelperName('affiliatereport/sales');
        $account = Mage::getSingleton('affiliate/session')->getAccount();
        if ($this->_getHelper()->getSharingConfig('balance') == 'store')
            $this->getDataHelper()->setParam('store', Mage::app()->getStore()->getId());
        $this->getDataHelper()->setParam('account_id', $account->getId());
        $this->setDataRows('transactions');
        $this->_axisMaps = array(
            'x' => 'range',
            'y' => 'transactions'
        );

        parent::_prepareData();
    }
}