<?php

$installer = $this;

$installer->startSetup();

$installer->run("

-- DROP TABLE IF EXISTS {$this->getTable('revslider')};
CREATE TABLE {$this->getTable('revslider')} (
  `revslider_id` int(11) unsigned NOT NULL auto_increment,
   title tinytext NOT NULL,
   alias tinytext,
   params text NOT NULL,
  `created_time` datetime NULL,
  `update_time` datetime NULL,
  PRIMARY KEY (`revslider_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- DROP TABLE IF EXISTS {$this->getTable('revslider')};
CREATE TABLE IF NOT EXISTS {$this->getTable('revslider/slide')} (
 `slide_id` int(10) NOT NULL auto_increment,
 `revslider_id` int(10) NOT NULL,
 `title` varchar(255) NOT NULL default '',
 `params` text NOT NULL default '',
 `layers` text NOT NULL default '',
 `status` varchar(255) NOT NULL default '1',
 `s_order` int(10) NOT NULL default '0',
 PRIMARY KEY  (`slide_id`),
 KEY `FK_revslider` (`revslider_id`),
 CONSTRAINT `FK_revslider` FOREIGN KEY (`revslider_id`) REFERENCES {$this->getTable('revslider')} (`revslider_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- DROP TABLE IF EXISTS {$this->getTable('revslider')};
CREATE TABLE IF NOT EXISTS {$this->getTable('revslider/caption')} (
 `caption_id` int(10) NOT NULL auto_increment,
  handle text NOT NULL,
  settings text,
  hover text,
  params text NOT NULL,
 PRIMARY KEY  (`caption_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- DROP TABLE IF EXISTS {$this->getTable('revslider')};
CREATE TABLE IF NOT EXISTS {$this->getTable('revslider/animation')} (
 `animation_id` int(10) NOT NULL auto_increment,
  handle text NOT NULL,
  params text NOT NULL,
 PRIMARY KEY  (`animation_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
");
$installer->run("INSERT INTO `revslider_caption` (`caption_id`, `handle`, `settings`, `hover`, `params`) VALUES
(1, '.tp-caption.big_yellow', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#ffd658\",\"text-shadow\":\"none\",\"font-weight\":\"400\",\"font-size\":\"100px\",\"line-height\":\"36px\",\"font-family\":\"''Open Sans''\",\"padding\":\"0px 4px\",\"padding-top\":\"1px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"background-color\":\"transparent\"}'),
(2, '.tp-caption.big_bluee', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"blue\",\"text-shadow\":\"none\",\"font-weight\":\"400\",\"font-size\":\"78px\",\"line-height\":\"36px\",\"font-family\":\"''Open Sans''\",\"padding\":\"0px 4px\",\"padding-top\":\"1px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"background-color\":\"transparent\"}'),
(3, '.tp-caption.big_white', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"700\",\"font-size\":\"36px\",\"line-height\":\"36px\",\"font-family\":\"Arial\",\"padding\":\"0px 4px\",\"padding-top\":\"1px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"background-color\":\"#000\",\"letter-spacing\":\"-1.5px\"}'),
(4, '.tp-caption.big_orange', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#ff7302\",\"text-shadow\":\"none\",\"font-weight\":\"700\",\"font-size\":\"36px\",\"line-height\":\"36px\",\"font-family\":\"Arial\",\"padding\":\"0px 4px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"background-color\":\"#fff\",\"letter-spacing\":\"-1.5px\"}'),
(5, '.tp-caption.big_black', '{\"hover\":\"\"}', '{\"font-size\":\"28px\",\"line-height\":\"28px\",\"font-weight\":\"normal\",\"font-family\":\"UbuntuMedium\",\"color\":\"#ffffff\",\"text-decoration\":\"none\",\"text-shadow\":\"none\",\"margin\":\"0px\",\"letter-spacing\":\"-1.5px\",\"padding\":\"10px 25px 10px 25px\",\"background-color\":\"rgba(49, 56, 72, 0.298039)\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 255, 255)\",\"border-style\":\"none\"}', '{\"font-size\":\"28px\",\"line-height\":\"40px\",\"font-weight\":\"normal\",\"font-family\":\"UbuntuMedium\",\"color\":\"#ffffff\",\"text-decoration\":\"none\",\"text-transform\":\"uppercase\",\"text-shadow\":\"none\",\"letter-spacing\":\"2px\",\"margin\":\"0px\",\"text-align\":\"left\",\"padding\":\"10px 25px 10px 25px\",\"background-color\":\"rgba(49, 56, 72, 0.298039)\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 255, 255)\",\"border-style\":\"none\"}'),
(6, '.tp-caption.medium_grey', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"font-weight\":\"700\",\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-family\":\"Arial\",\"padding\":\"2px 4px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"background-color\":\"#888\",\"white-space\":\"nowrap\"}'),
(7, '.tp-caption.small_text', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"font-weight\":\"700\",\"font-size\":\"14px\",\"line-height\":\"20px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}'),
(8, '.tp-caption.medium_text', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"font-weight\":\"700\",\"font-size\":\"20px\",\"line-height\":\"20px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}'),
(9, '.tp-caption.large_text', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"font-weight\":\"700\",\"font-size\":\"40px\",\"line-height\":\"40px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}'),
(10, '.tp-caption.very_large_text', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"0px 2px 5px rgba(0, 0, 0, 0.5)\",\"font-weight\":\"700\",\"font-size\":\"60px\",\"line-height\":\"60px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\",\"letter-spacing\":\"-2px\"}'),
(11, '.tp-caption.very_big_white', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"800\",\"font-size\":\"60px\",\"line-height\":\"60px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\",\"padding\":\"0px 4px\",\"padding-top\":\"1px\",\"background-color\":\"#000\"}'),
(12, '.tp-caption.very_big_black', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#000\",\"text-shadow\":\"none\",\"font-weight\":\"700\",\"font-size\":\"60px\",\"line-height\":\"60px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\",\"padding\":\"0px 4px\",\"padding-top\":\"1px\",\"background-color\":\"#fff\"}'),
(13, '.tp-caption.modern_medium_fat', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#000\",\"text-shadow\":\"none\",\"font-weight\":\"800\",\"font-size\":\"24px\",\"line-height\":\"20px\",\"font-family\":\"''Open Sans'', sans-serif\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}'),
(14, '.tp-caption.modern_medium_fat_white', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"800\",\"font-size\":\"24px\",\"line-height\":\"20px\",\"font-family\":\"''Open Sans'', sans-serif\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}'),
(15, '.tp-caption.modern_medium_light', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#000\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"24px\",\"line-height\":\"20px\",\"font-family\":\"''Open Sans'', sans-serif\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}'),
(16, '.tp-caption.modern_big_bluebg', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"800\",\"font-size\":\"30px\",\"line-height\":\"36px\",\"font-family\":\"''Open Sans'', sans-serif\",\"padding\":\"3px 10px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"background-color\":\"#4e5b6c\",\"letter-spacing\":\"0\"}'),
(17, '.tp-caption.modern_big_redbg', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#fff\",\"text-shadow\":\"none\",\"font-weight\":\"300\",\"font-size\":\"30px\",\"line-height\":\"36px\",\"font-family\":\"''Open Sans'', sans-serif\",\"padding\":\"3px 10px\",\"padding-top\":\"1px\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"background-color\":\"#de543e\",\"letter-spacing\":\"0\"}'),
(18, '.tp-caption.modern_small_text_dark', NULL, NULL, '{\"position\":\"absolute\",\"color\":\"#555\",\"text-shadow\":\"none\",\"font-size\":\"14px\",\"line-height\":\"22px\",\"font-family\":\"Arial\",\"margin\":\"0px\",\"border-width\":\"0px\",\"border-style\":\"none\",\"white-space\":\"nowrap\"}'),
(19, '.tp-caption.boxshadow', NULL, NULL, '{\"-moz-box-shadow\":\"0px 0px 20px rgba(0, 0, 0, 0.5)\",\"-webkit-box-shadow\":\"0px 0px 20px rgba(0, 0, 0, 0.5)\",\"box-shadow\":\"0px 0px 20px rgba(0, 0, 0, 0.5)\"}'),
(20, '.tp-caption.black', NULL, NULL, '{\"color\":\"#000\",\"text-shadow\":\"none\"}'),
(21, '.tp-caption.noshadow', NULL, NULL, '{\"text-shadow\":\"none\"}'),
(22, '.tp-caption.slider_h3', '{\"hover\":\"\"}', '{\"font-size\":\"28px\",\"line-height\":\"28px\",\"font-weight\":\"normal\",\"font-family\":\"UbuntuMedium\",\"color\":\"#ffffff\",\"text-decoration\":\"none\",\"text-shadow\":\"none\",\"margin\":\"0px\",\"letter-spacing\":\"-1.5px\",\"padding\":\"10px 25px 10px 25px\",\"background-color\":\"rgba(49, 56, 72, 0.298039)\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 255, 255)\",\"border-style\":\"none\"}', '{\"font-size\":\"16px\",\"line-height\":\"28px\",\"font-weight\":\"normal\",\"color\":\"#ffffff\",\"text-decoration\":\"none\",\"text-shadow\":\"none\",\"margin\":\"0px\",\"text-align\":\"left\",\"text-transform\":\"capitalize\",\"padding\":\"6px 20px 6px 20px\",\"background-color\":\"rgba(49, 56, 72, 0.290196)\",\"border-width\":\"0px\",\"border-color\":\"rgb(255, 255, 255)\",\"border-style\":\"none\"}'),
(23, '.tp-caption.slider_h2', '{\"hover\":\"\"}', '{\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"border-width\":\"0px\",\"border-color\":\"rgb(34, 34, 34)\",\"border-style\":\"none\"}', '{\"font-size\":\"40px\",\"line-height\":\"44px\",\"font-family\":\"UbuntuMedium\",\"color\":\"#ffffff\",\"text-decoration\":\"none\",\"padding\":\"10px 20px 10px 20px\",\"text-transform\":\"uppercase\",\"background-color\":\"rgba(61, 70, 90, 0.4)\",\"letter-spacing\":\"10px\",\"border-width\":\"0px\",\"border-color\":\"rgb(34, 34, 34)\",\"border-style\":\"none\"}'),
(24, '.tp-caption.img', '{\"hover\":\"\"}', '\"\"', '{\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"z-index\":\"0\",\"position\":\"relative\",\"border-width\":\"0px\",\"border-color\":\"rgb(34, 34, 34)\",\"border-style\":\"none\"}'),
(25, '.tp-caption.images', '{\"hover\":\"\"}', '\"\"', '{\"text-decoration\":\"none\",\"background-color\":\"transparent\",\"z-index\":\"0\",\"position\":\"relative\",\"border-width\":\"0px\",\"border-color\":\"rgb(34, 34, 34)\",\"border-style\":\"none\"}');
");

$helper =  Mage::helper('revslider/data'); 
$helper ->importRevsliderData();
$installer->endSetup(); 