<?php
class Schogini_Addtocart_Model_Update_Feed extends Schogini_Addtocart_Model_Update_Abstract
{

    public function getFeedUrl()
    {
        return 'https://s3-us-west-2.amazonaws.com/schogini.biz/newsfeed/magento_feed.xml';
    }

    public function check()
    {
        $frequency = 14 * 24 * 60 * 60; // 14 days in seconds
        if (!Mage::app()->loadCache('schogini_notify_feed_lastcheck') || (time() - Mage::app()->loadCache('schogini_update_feed_lastcheck')) > $frequency) {
            $this->refresh();
        }
    }

    function refresh()
    {
        $feedData = array();

        try {
            $Node = $this->getFeedData();

            if (!$Node) {
                return false;

            }

            foreach ($Node->children()->channel->children() as $tagName => $item) {
                if ($tagName == 'item') {
                    if ($this->isExtensionInstalled($item)) {
                        $feedData[] = array(
                            'severity'      => intval($item->severity),
                            'date_added'    => $this->getDate((string)$item->pubDate),
                            'title'         => (string)$item->title,
                            'description'   => (string)$item->description,
                            'url'           => (string)$item->link,
                        );
                    }
                }
            }

            $adminnotificationModel = Mage::getModel('adminnotification/inbox');
            if ($feedData && is_object($adminnotificationModel)) {
                $adminnotificationModel->parse(($feedData));
            }

            Mage::app()->saveCache(time(), 'schogini_update_feed_lastcheck');
            return true;

        } catch (Exception $E) {
            return false;

        }
    }

    // Sometimes you may need notifications to be shown only if, certain extensions are installed (like module updates)
    // This function will check if, there is an extensions section in the XML item and if so, check if, the extensions 
    // listed are installed. Currently, we do not need this since, we are going to push notify new modules only.
    public function isExtensionInstalled($item)
    {
        return true; // don't use it at the moment.

        $exts = @explode(",", (string)$item->extensions);
        $modules = array_keys((array)Mage::getConfig()->getNode('modules')->children());
        foreach ($exts as $ext) {
            foreach ($modules as $moduleName) {
                if ($moduleName == $ext) {
                    return true;
                }
            }
        }
        return false;
    }

}